// -*- mode: java -*- 
/* 

    SnakeCharmer, and MRML complient JAVA interface for CBIRs
    Copyright (C) 1998-1999 Zoran Pecenovic & LCAV, EPF Lausanne

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
package charmer.client;

import java.awt.*;


public class ProgressThreadDriver
extends Thread
{
		Color phaseC[];
		long phaseS[];
		int currentPhase;
		int phaseCount;
		ProgressThread displayer;

		public ProgressThreadDriver(int pC, ProgressThread disp){
				phaseCount=pC;
				displayer=disp;
				phaseC=new Color[phaseCount];
				phaseS=new long[phaseCount+1];
				currentPhase=phaseCount;				
				displayer.setMaxProgress(1000);
				displayer.pcol = phaseC[currentPhase-1];
				for(int i=0;i<phaseCount;i++) {
						phaseC[i] = Color.getHSBColor((float)i/(float)phaseCount,80,85);						
				}
				phaseS[currentPhase]=System.currentTimeMillis();
				run();
		}

		public void run(){				
				while(currentPhase>0){
						try{
								sleep(2);
						} catch(InterruptedException ie){
								currentPhase--;
								phaseS[currentPhase] = System.currentTimeMillis();
								displayer.pcol = phaseC[currentPhase-1];
						}
						if(displayer.getProgress()==1000) displayer.setProgress(0);
						else displayer.incrementProgress();
				}
				//here we know all the times etc, so we can actually make 
				// the progress reflect the different phase durations
		}
}
