// -*- mode: java -*- 
/* 

   Viper, a flexible content based image retrieval system.
   Copyright (C) 1998-1999 CUI, University of Geneva

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
package charmer.mrml;

import java.net.*;
import java.util.*;
import java.io.*;
import java.awt.Panel;
import java.lang.String;
import charmer.mrml.*;
import charmer.client.*;
import org.xml.sax.AttributeList;


/** 
    This is a class which generates an XML subtree from a visit of
    a property sheet.
    @author Wolfgang Mller
*/
public class CXEVProperty implements CXMLElementVisitor{
    /**
    
       a class for building property sheets in a way which 
       corresponds well to 

     */
    CPropertyBuilder mPropertyBuilder;

    protected int lState=0;
    /** 
     */
    public CXEVProperty(){
	mPropertyBuilder= new CPropertyBuilder();
    };
    /**
     */

    public boolean startVisit(CXMLElement inElement){

	String        name=inElement.getName();
	if(0==name.compareTo(mrml_const.property_sheet)){
	    AttributeList attrs=inElement.getAttributes();

	    mPropertyBuilder.addChild(attrs);
	    return true;
	}
	return false;
    }
    public void endVisit(CXMLElement inElement){
	mPropertyBuilder.moveUp();
    }

    public Panel getPanel(){
	return mPropertyBuilder.getPanel();
    }
    public CPropertyElement getPropertyElement(){
	return mPropertyBuilder.getPropertyElement();
    }
};

